#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "ImageData.h"
#ifdef _DEBUG
#ifdef WIN32
#include <crtdbg.h>
#endif
#endif

/**
 *@brief RXgN^
 *@note C[Wf[^p|C^Aщ摜̕ENA
 */
ImageData::ImageData(void) : 
	m_width(0), 
	m_height(0),
	m_image(0),
	m_cvImage(0),
	m_cvSimImage(0)

{
}

/**
 *@brief fXgN^
 *@note mۂĂC[Wf[^̈j
 */
ImageData::~ImageData(void)
{
	DeleteImage();
}

/**
 *@brief Rs[RXgN^
 *@param src Rs[ImageDataCX^X
 */
ImageData::ImageData(const ImageData& src)
{
	m_image			= 0;
	m_cvImage		= 0;
	m_cvSimImage	= 0;

	CreateImage(src.m_width ,src.m_height);
	memcpy(m_image, src.m_image, src.m_width * src.m_height);
}

/**
 *@brief C[W̏ݍ݂sB
 *@note 摜1/4TCYɏݍŐVImageDataB
 *@return 1/4TCYɏݍ񂾉摜f[^B
 */
ImageData ImageData::PyrDown()
{
	ImageData		result;
	unsigned long	width, height;

	unsigned long h_cnt, w_cnt;
	unsigned long x_pos, y_pos;

	width	= m_width / 2;
	height	= m_height / 2;
	result.CreateImage(width, height);

	for ( h_cnt = 0; h_cnt < height; h_cnt++ ) {	/* dst̍[v */
		for( w_cnt = 0; w_cnt < width; w_cnt++ ) {	/* dst̕[v */
			x_pos = (w_cnt * 2);			/* 0,2,4,6,EEEsrc̊sNZԈ */
			y_pos = (h_cnt * 2) * m_width;	/* 0,2,4,6,EEEsrc̊ssNZԈ */
			/*
				摜̉E[f[^i[EEE
				\[X̃Rs[ΏۃsNZƉEEEE(ԈsNZ)̃sNZl̕ς
				EEE[E[Ɋi[̂ŋɂȂ
			*/
			/*
				^[QbgW	= X
				ݑΏ	= O

				+ + + + + + +
				+ + + + + + +
				+ + + +X+O+ +
				+ + + +O+O+ +
				+ + + + + + +
				+ + + + + + +
			*/
			result[ (int)(h_cnt * width + (width - w_cnt - 1)) ]
				= (unsigned int)( m_image[ y_pos + x_pos ] +	
								  m_image[ y_pos + x_pos + m_width] +
								  m_image[ y_pos + x_pos + 1 ] +
								  m_image[ y_pos + x_pos + 1 + m_width ] ) / 4;
		}
	}

	return result;
}

/**
 *@brief C[Wf[^`ϊ
 *@param orgData CameraEyeComp瑗Ă摜f[^
 *@attention CameraEyeComp瑗Ăf[^ϊłȂB
 */
void ImageData::SetData(TimedOctetSeq orgData)
{
	unsigned char	*imgData;

	DeleteImage();

	/* oCizK؂ȏԂɕύX */
	if(orgData.data.length() > 0){
		imgData = (unsigned char*)malloc(orgData.data.length());
		memcpy(imgData, (unsigned char*)(&(orgData.data[0])), orgData.data.length());
		m_cvSimImage = (IplImage *)imgData;
		m_cvSimImage->roi = NULL;
		m_cvSimImage->maskROI = NULL;
		m_cvSimImage->imageId = NULL;
		m_cvSimImage->tileInfo = NULL;
		m_cvSimImage->imageDataOrigin = NULL;
		m_cvSimImage->imageData = (char*)(&(imgData[sizeof(IplImage)]));
		SetData(m_cvSimImage);
	}
}

/**
 *@brief C[Wf[^̈쐬
 *@param width 摜̕
 *@param height 摜̍
 */
void ImageData::CreateImage(const unsigned long width, const unsigned long height)
{
	m_width		= width;
	m_height	= height;

	DeleteImage();
	m_image = (unsigned char *)malloc( width * height );
	if(m_image == 0) {
		fprintf(stderr, "Can't malloc");
	}
	Clear(MAX_BRIGHTNESS);
}

/**
 *@brief C[Wf[^̈̒lŖ߂
 *@param value ߍ݂f[^(ftHgł0xFF)
 */
void ImageData::Clear(unsigned char value)
{
	if(m_image != 0)
		memset(m_image, value, m_width * m_height);
}

/**
 *@brief C[Wf[^̈J
 *
 */
void ImageData::DeleteImage()
{
	if(m_image != 0)
		free(m_image);
	m_image = 0;

	if(m_cvImage != 0)
		cvReleaseImage(&m_cvImage);
	m_cvImage = 0;

	if(m_cvSimImage)
		free(m_cvSimImage);
	m_cvSimImage = 0;
}

/**
 *@brief C[Wf[^ǂݍ݁A2l摜ɕϊ܂B
 *@note OpenCVcvLoadImageœǂݍ݉\Ȍ`łΓǂݍ݂܂B
 *@param fileName ǂݍރC[Wt@C
 *@param flags cvLoadImageɓnflagsl
 *@attention flagśA{֐CV_LOAD_IMAGE_ANYDEPTHݒ肳܂B
 *@return 0:A-1:ǂݍ݃G[
 */
int	ImageData::LoadImage(std::string fileName, int flags)
{
	/* C[Ẅ̔jsĂ */
	DeleteImage();

	m_cvImage = cvLoadImage(fileName.c_str(), flags | CV_LOAD_IMAGE_ANYDEPTH);
	if(m_cvImage == 0)	return -1;
	SetData(m_cvImage);

	return 0;
}

/**
 *@brief C[Wf[^`ϊ
 *@param cvImage OpenCV`f[^
 *@attention Sp^[킯ł͂Ȃ̂ŁAϊoɗ鎖邩EEEB
 */
void ImageData::SetData(IplImage *cvImage)
{
	IplImage	*grayImage = 0;
	char		*imageData;

	/* 摜̕EƂ肠i[Ă */
	m_width		= cvImage->width;
	m_height	= cvImage->height;
	imageData	= cvImage->imageData;

	if((cvImage->width * cvImage->height) != cvImage->imageSize){
		/* C[Wf[^J[摜 or ACgĂ */
		/* ŏIInChannels=1,depth=IPL_DEPTH_8U or 8S ɂȂΗǂ */
		if(cvImage->nChannels != 1){
			/* J[摜炵 */
			/* O[XP[ɕϊ */
			grayImage = cvCreateImage( cvGetSize(cvImage)  , IPL_DEPTH_8U, 1 );
			cvCvtColor(cvImage, grayImage, CV_BGR2GRAY);
			imageData = grayImage->imageData;
		}
		else{
			/* O[XP[ or l摜Ȃ̂ŁAACgĂ邾 */
			m_width		= cvImage->widthStep;
			m_height	= cvImage->height;
		}

	}

	m_image		= (unsigned char *)malloc(m_width * m_height);
	memcpy(m_image, imageData, m_width * m_height);
	if(grayImage != 0)	cvReleaseImage(&grayImage);
}

/**
 *@brief C[Wf[^̑Iy[^
 *@attention {Iy[^ł́A{NXœƎ`ĂC[Wf[^̂ݑȂ2`̃C[Wf[^͑ȂB
 */
ImageData& ImageData::operator=(const ImageData& org)
{
	CreateImage(org.m_width, org.m_height);
	memcpy(m_image, org.m_image, org.m_width * org.m_height);
	return *this;
}
