#pragma once

#include <rtm/idl/BasicDataTypeSkel.h>

#include "std_hdr.h"
#include "cv.h"
#include "highgui.h"

#define MAX_BRIGHTNESS	255		/* C[Wf[^l	*/

using namespace RTC;

/**
 *@brief 2lC[Wf[^ǗNX
 *@note ɂ́AOpenCṼfvXrbgIPL_DEPTH_8ÛŃO[XP[ĂB
 *@attention J[C[W͂ۂɂ́AOɃO[XP[ɕϊĂƂ𐄏B
 */
class ImageData
{
public:
	ImageData(void);					/* RXgN^		*/
	~ImageData(void);					/* fXgN^			*/
	ImageData(const ImageData& src);	/* Rs[RXgN^ */

/* J֐ */
public:
	void CreateImage(const unsigned long width, const unsigned long height);	/* 2lC[Wf[^̈쐬 				*/
	void Clear(unsigned char value = MAX_BRIGHTNESS);							/* C[Wf[^̈揉 				*/
	void DeleteImage();															/* C[Wf[^̈j					*/
	ImageData PyrDown();														/* 摜̏ݍ							*/
	void SetData(TimedOctetSeq orgData);										/* C[Wf[^ϊ						*/
	void SetData(IplImage *cvImage);											/* OpenCV`C[WƎ`ɕϊ 	*/
	int	LoadImage(std::string fileName, int flags = CV_LOAD_IMAGE_ANYCOLOR);	/* C[Wf[^ǂݍ					*/

	/**
	 *@brief C[Wf[^̕擾܂
	 *@return C[Wf[^̕
	 */
	unsigned long GetWidth()	{ return m_width; }								/* C[W̎擾							*/

	/**
	 *@brief C[Wf[^̍擾܂
	 *@return C[Wf[^̍
	 */
	unsigned long GetHeight()	{ return m_height; }							/* C[W̎擾						*/

/* operator */
public:
#ifdef WIN32
	/**
	 *@brief C[Wf[^ւ̔z`ANZX
	 */
	unsigned char &operator[](size_t index)	{ return m_image[index];	}
#endif

	/**
	 *@brief C[Wf[^ւ̔z`ANZX
	 */
	unsigned char &operator[](int index)	{ return m_image[index];	}

	/**
	 *@brief C[Wf[^ւ2z`ANZX
	 *@param x : XWʒu
	 *@param y : YWʒu
	 */
	unsigned char &operator()(size_t x, size_t y)	{ return m_image[x + y * m_width];	}

	/**
	 *@brief C[Wf[^ւ̃|C^擾
	 */
	operator unsigned char*()				{ return m_image;			}

	/**
	 *@brief {NX̑
	 */
	ImageData& operator=(const ImageData& org);

private:
	unsigned long	m_width;		/* C[Wf[^						*/
	unsigned long	m_height;		/* C[Wf[^					*/
	unsigned char	*m_image;		/* C[Wf[^̈					*/
	IplImage		*m_cvImage;		/* OpenCV`C[Wf[^̈			*/
	IplImage		*m_cvSimImage;	/* [OpenCV`C[Wf[^̈		*/
};
